/*
 * Upbit Open API
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.18
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.UpbitOpenApi) {
      root.UpbitOpenApi = {};
    }
    root.UpbitOpenApi.BidAccount = factory(root.UpbitOpenApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The BidAccount model module.
   * @module model/BidAccount
   * @version 1.0.0
   */

  /**
   * Constructs a new <code>BidAccount</code>.
   * 매수 시 사용하는 화폐의 계좌 상태
   * @alias module:model/BidAccount
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>BidAccount</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/BidAccount} obj Optional instance to populate.
   * @return {module:model/BidAccount} The populated <code>BidAccount</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('currency'))
        obj.currency = ApiClient.convertToType(data['currency'], 'String');
      if (data.hasOwnProperty('balance'))
        obj.balance = ApiClient.convertToType(data['balance'], 'String');
      if (data.hasOwnProperty('locked'))
        obj.locked = ApiClient.convertToType(data['locked'], 'String');
      if (data.hasOwnProperty('avg_buy_price'))
        obj.avgBuyPrice = ApiClient.convertToType(data['avg_buy_price'], 'String');
      if (data.hasOwnProperty('avg_buy_price_modified'))
        obj.avgBuyPriceModified = ApiClient.convertToType(data['avg_buy_price_modified'], 'Boolean');
      if (data.hasOwnProperty('unit_currency'))
        obj.unitCurrency = ApiClient.convertToType(data['unit_currency'], 'String');
    }
    return obj;
  }

  /**
   * 화폐를 의미하는 영문 대문자 코드
   * @member {String} currency
   */
  exports.prototype.currency = undefined;

  /**
   * 주문가능 금액/수량
   * @member {String} balance
   */
  exports.prototype.balance = undefined;

  /**
   * 주문 중 묶여있는 금액/수량
   * @member {String} locked
   */
  exports.prototype.locked = undefined;

  /**
   * 매수평균가
   * @member {String} avgBuyPrice
   */
  exports.prototype.avgBuyPrice = undefined;

  /**
   * 매수평균가 수정 여부
   * @member {Boolean} avgBuyPriceModified
   */
  exports.prototype.avgBuyPriceModified = undefined;

  /**
   * 평단가 기준 화폐
   * @member {String} unitCurrency
   */
  exports.prototype.unitCurrency = undefined;


  return exports;

}));
